' Region Description
'
' Name: Autofit text file to excel
' Author: Kushal Teja Pulijala
' Version: 0.1
' Description:

'MsgBox ("Today is " &Date &" "  &Time)
'File Declarations

If (Hour(Now()) < 3) Then
                                BusinessDate = DateAdd("D", -1, Now())
                Else
                                BusinessDate = Now()
End If

y = Year(BusinessDate) 
  m = Month(BusinessDate) : If Len(m)=1 Then m = "0" & m : End If
  d = Day(BusinessDate) : If Len(d)=1 Then d = "0" & d : End If
  h = Hour(BusinessDate) : If Len(h)=1 Then h = "0" & h : End If
  n = Minute(BusinessDate) : If Len(n)=1 Then : n = "0" & n : End If
  s = Second(BusinessDate) : If Len(s)=1 Then : s = "0" & s : End If
  MyDate = y & "." & m & "." & d & "-" & h & "." & n & "." & s
Datefrmt = y & m & d 

' *************************************************************
' ***  Set Constant XML File Name 
' *************************************************************
Const ConfigFile = "config.xml"

'AdvLogging = RdTier1XML("AdvLogging", ConfigFile)

FileLoc = RdXML("InputFileLoc", ConfigFile) &Datefrmt &"ca_cash_receipt.txt" 
TmpFileLoc = RdXML("InputFileLoc", ConfigFile) &"tmp_ca_cash_receipt.txt"
TmpFilexls = RdXML("InputFileLoc", ConfigFile) &"ca_cash_receipt.xls"
Archivexls = RdXML("ArchiveLoc", ConfigFile) & Datefrmt & "ca_cash_receipt.xls"
Archivetxt = RdXML("ArchiveLoc", ConfigFile) &Datefrmt &"ca_cash_receipt.txt"
XlsFile = RdXML("InputFileLoc", ConfigFile) &Datefrmt &"ca_cash_receipt.xls"
logfile = RdXML("LogfilePath", ConfigFile) & "\log" & Datefrmt & ".txt"
ServerPath = "\\" & RdXML("ServerAddress", ConfigFile) & RdXML("ServerLocation", ConfigFile) &Datefrmt &"ca_cash_receipt.xls"
SpoolingTime = RdXML("SpoolingTime", ConfigFile)

'MsgBox MyDate
'-------------------------------------------------------------------------------
' Logtext - Log file Creation Script
' Parameters:
'   sFile - The file to read
' 
' Returns:
'   A string containing the content of the file.
'-------------------------------------------------------------------------------
Function Logtext(sFilePath, sText)
    Dim objFSO 'As FileSystemObject
    Dim objTextFile 'As Object
    
    Const ForReading = 1
    Const ForWriting = 2
    Const ForAppending = 8
    
    Set objFSO1 = CreateObject("Scripting.FileSystemObject")
                
                If objFSO1.FileExists(sFilePath) Then
                                Set objTextFile = objFSO1.OpenTextFile(sFilePath, ForAppending, True) 
                                ' Write a line.
                objTextFile.Write (Date & " " & Time & " ---------- " & sText & VbCrLf)
                                objTextFile.Close
                                Else
                                Set objTextFile = objFSO1.CreateTextFile(sFilePath,True)
                                ' Write a line.
                objTextFile.Write (Date & " " & Time & " ---------- " & sText & VbCrLf)
                                objTextFile.Close
                End If

    
    'objTextFile.Close

End Function

'Check if the file exists

Set objFSO = CreateObject("Scripting.FileSystemObject")

' While objFSO.FileExists("C:\Users\kpulijala\Desktop\VBScript\ca_cash_receipt.txt") 
'                MsgBox "File Exists"
' Wend
' 
Logtext logfile, "Script Initiated"


Do Until (objFSO.FileExists (FileLoc))
                Logtext logfile, "File not found, waiting for the file to arrive"
                WScript.Sleep SpoolingTime
                Loop

Logtext logfile, "File Found"

If objFSO.FileExists (TmpFileLoc) Then
                objFSO.DeleteFile(TmpFileLoc)
                objFSO.CopyFile FileLoc , TmpFileLoc
Else
                objFSO.CopyFile FileLoc , TmpFileLoc
End If



' AutoFit Columns in a Microsoft Excel Worksheet
'Region converttxt2xls

Dim CSVBook 
Dim filename
Dim objExcel, ObjWs
Dim LastCol, wb
Set objExcel = CreateObject("Excel.Application")
objExcel.Visible = True
Const xlDelimited                =  1
Const xlOpenXMLWorkbook          = -4143

' Because the Excel workbook tab has a temp name to it. changing it to original file just before formatting to excel
If objFSO.FileExists (FileLoc) Then
                objFSO.DeleteFile(FileLoc)
                objFSO.CopyFile TmpFileLoc , FileLoc
Else
                objFSO.CopyFile TmpFileLoc , FileLoc
End If


objExcel.Workbooks.OpenText FileLoc, , , xlDelimited, , , , , , , True, "|"

Set wb = objExcel.ActiveWorkbook
Set ObjWs  = objExcel.Sheets(1)

For column=1 To 15
ObjWs.columns(column).AutoFit() 
 Next 


wb.SaveAs TmpFilexls, xlOpenXMLWorkbook, , , , False
wb.Close

objExcel.Quit
Logtext logfile, "Excel Formating Completed"
'Check to see if file exists
If objFSO.FileExists (XlsFile) Then
objFSO.DeleteFile(XlsFile)
objFSO.MoveFile TmpFilexls , XlsFile
Else
objFSO.MoveFile TmpFilexls , XlsFile
End If

'Archiving the Excel file

If objFSO.FileExists (Archivexls) Then
objFSO.DeleteFile (Archivexls)
objFSO.CopyFile XlsFile, Archivexls
Else
objFSO.CopyFile XlsFile, Archivexls
End If

Logtext logfile, "Excel File Archived"

'Archived input text file
If objFSO.FileExists (Archivetxt) Then
                objFSO.DeleteFile(Archivetxt)
                objFSO.CopyFile FileLoc , Archivetxt
Else
                objFSO.CopyFile FileLoc , Archivetxt
End If

Logtext logfile, "Cash Receipt Text File Archived"

objFSO.DeleteFile TmpFileLoc

If objFSO.FileExists (ServerPath) Then
                objFSO.DeleteFile(ServerPath)
                objFSO.CopyFile XlsFile , ServerPath
Else
                objFSO.CopyFile XlsFile , ServerPath
End If


'Logtext logfile, "Excel Formating Completed"

Logtext logfile, "Script Executed Successfully"

'EndRegion


' EndRegion

Function RdXML (param, file)
Set objXMLDoc = CreateObject("Microsoft.XMLDOM")
objXMLDoc.async = False
objXMLDoc.load(file)

 Set Root = objXMLDoc.documentElement
Set Node = Root.selectSingleNode(param)
RdXML = Node.Text

Set objXMLDoc = Nothing
Set Node = Nothing
Set Root = Nothing
End Function
